/*-------------------------------------------------------*/
/* format of .DVP file (superset of TopView .PIF file)   */

typedef struct
   {
   BYTE unknown0 ;            /* I see 0 always */
   BYTE checksum ;            /* makes sum of bytes of .PIF file equal zero */
   char program_name[30] ;    /* blank-padded */
   WORD max_memory ;          /* in K */
   WORD min_memory ;          /* in K */
   char executable_name[64] ; /* blank-padded */
   BYTE data_drive ;          /* 0 = default, else drive letter ('A',...) */
   char data_directory[64] ;  /* ASCIZ */
   char parameters[64] ;      /* ASCIZ */
   BYTE video_mode ;          /* 7Fh = use current */
   BYTE num_text_pages ;
   BYTE lowest_int ;          /* number of lowest interrupt program changes */
   BYTE highest_int ;         /* number of highest interrupt program changes */
   BYTE max_win_height ;
   BYTE max_win_width ;
   BYTE starting_row ;        /* 0 = use default */
   BYTE starting_col ;        /* 0 = use default */
   WORD total_overhead_RAM ;  /* how many K to allocate for system RAM */
                              /* (= requested + amt needed for screen buffer) */
   char shared_program[64] ;  /* ASCIZ */
   char shared_prg_data[64] ; /* ASCIZ */
   BYTE flags1 ;              /* bit 7 = set if writes directly to screen */
                              /* bit 6 = set if runs only in foreground */
                              /* bit 5 = set if uses math coprocessor */
                              /* bit 4 = set if "Keyboard Conflict" = 4 */
                              /* bit 3 = set if */
                              /* bit 2 = set if */
                              /* bit 1 = set if */
                              /* bit 0 = set if can be swapped out */
   BYTE flags1a ;             /* bit 6 = set if command line present */

/* everything up to this point is identical to a TopView .PIF file */
/* the remainder is unique to a DESQview .DVP file.  Note that there */
/* is some duplication of information */

   char open_keys[2] ;
   WORD script_buffer_size ;  /* in bytes */
   BYTE flags2 ;              /* bit 7 =  */
                              /* bit 2 = set if "Writes directly..." = '!' */
   BYTE unknown176h ;
   BYTE uses_own_colors ;     /* 1 = yes,  0 = no */
   BYTE unknown178h ;
   BYTE unknown179h ;
   BYTE unknown17Ah ;
   BYTE unknown17Bh ;
   BYTE close_on_exit ;       /* 1 = close on exit, 0 = don't */
   BYTE unknown17Dh ;
   BYTE unknown17Eh ;
   BYTE unknown17Fh ;
   BYTE starting_height ;     /* 0 = use default */
   BYTE starting_width ;      /* 0 = use default */
   WORD max_expanded_mem ;    /* in K, FFFFh = no limit */
   BYTE flags3 ;              /* bit 7 =  */
                              /* bit 6 =  */
                              /* bit 5 =  */
                              /* bit 4 = 1 don't allow close window cmd */
                              /* bit 3 = set if "Runs only in fg" = ' ' */
                              /* bit 2 =  */
                              /* bit 1 =  */
                              /* bit 0 =  */
   BYTE keyboard_conflict ;   /* 0 thru 4 */
   BYTE num_graphics_pages ;
   WORD system_RAM ;          /* amount of SYSTEM RAM requested, in K */
   BYTE initial_video_mode ;  /* FFh = use current mode if compatible */
   BYTE reserved[22] ;        /* currently unused */
   } DVP_file ;

