/*=======================================================*/
/*  TVMASYNC.C                                           */
/*                                                       */
/*  (c) Copyright 1988 Ralf Brown  All Rights Reserved   */
/*  May be freely copied for noncommercial use, so long  */
/*  as this copyright notice remains intact, and any     */
/*  changes are marked in the comment blocks preceding   */
/*  functions.                                           */
/*=======================================================*/

#include "tvapi.h"
#include "tvstream.h"

/*=======================================================*/
/* TVwin_async  set asynchronous notification function   */
/*   Ralf Brown 4/4/88                                   */
/*=======================================================*/

void pascal TVwin_async(OBJECT win,void far (*func)())
{
   static BYTE stream[] = { S_MANAGER(10), MS_PRIM_ASYNC, 0,0,0,0,
                                           MS_SEC_ASYNC, 0,0,0,0 } ;

   *((unsigned far **)(stream+5)) = (unsigned far *) _TVnotify_handler ;
   *((unsigned far **)(stream+10)) = (unsigned far *) func ;
   TVwin_stream(win,stream) ;
}

/*=======================================================*/
/* TVwin_notify  enable notification of specific event   */
/*   Ralf Brown 4/4/88                                   */
/*=======================================================*/

void pascal TVwin_notify(OBJECT win,int event)
{
   static BYTE stream[] = { S_MANAGER(1), 0 } ;

   stream[4] = event | MS_NOTIFY ;
   TVwin_stream(win,stream) ;
}

/*=======================================================*/
/* TVwin_cancel  cancel notification of specific event   */
/*   Ralf Brown 4/4/88                                   */
/*=======================================================*/

void pascal TVwin_cancel(OBJECT win,int event)
{
   static BYTE stream[] = { S_MANAGER(1), 0 } ;

   stream[4] = event | MS_NONOTIFY ;
   TVwin_stream(win,stream) ;
}

/* End of TVMASYNC.C */
