/*================================================*/
/* TVPSCALE.C                                     */
/*                                                */
/* (c) Copyright 1988 Ralf Brown                  */
/*     All Rights Reserved                        */
/* May be freely copied for noncommercial use as  */
/* long as this copyright notice is kept intact   */
/* and any changes are indicated in the comment   */
/* blocks for the functions                       */
/*================================================*/

#include "tvapi.h"

/*================================================*/
/* TVptr_setscale  set pointer scale factors      */
/*                 pointer coords scaled so that  */
/*                 bottom edge of window is "rows"*/
/*                 and right edge is "cols"       */
/*   Ralf Brown 6/13/88                           */
/*================================================*/

void pascal TVptr_setscale(OBJECT ptr,int rows,int cols)
{
   PARMLIST2 p ;

   if (TVisobj(ptr))
      {
      p.num_args = 2 ;
      p.arg[0] = rows ;
      p.arg[1] = cols ;
      TVsendmsg(SETSCALE_MSG, TOS, ptr, (PARMLIST *)&p) ;
      }
}

/*================================================*/
/* TVptr_getscale  get pointer scale factors      */
/*   Ralf Brown 6/13/88                           */
/*================================================*/

void pascal TVptr_getscale(OBJECT ptr,int *rows,int *cols)
{
   PARMLIST2 p ;

   if (TVisobj(ptr))
      {
      p.num_args = 0 ;
      TVsendmsg(GETSCALE_MSG, TOS, ptr, (PARMLIST *)&p) ;
      *rows = (int) p.arg[0] ;
      *cols = (int) p.arg[1] ;
      }
}

/* End of TVPSCALE.C */
