#ifndef DVGLUE_version
#error Include TVAPI.H before this file
#endif

/***********************************************************/
/* Constants for UImenu_build() and typedef MENU_ITEM      */
/***********************************************************/

/* types of menu items */
#define M_END     0     /* marks end of array of menu items */
#define M_ITEM    1     /* menu selection */
#define M_SPECIAL 2     /* special key.  Text after last blank is  */
                        /* right-justified as menu key             */
#define M_TEXT    3     /* descriptive text, not a selection */
#define M_HTEXT   4     /* highlighted version of above */
#define M_CENTER  5     /* centered text, not a selection */
#define M_HCENTER 6     /* highlighted version of above */
#define M_SEP     7     /* separator line, item.key1 is replicated */
#define M_IGNORE  8     /* ignore this entry.  Useful for "commenting out" */

/* actions returned by test function, may be ORed together */
#define MA_REDO   0     /* read menu again  \ mutually exclusive */
#define MA_DONE   1     /* return to caller /                    */
#define MA_BEEP   2     /* beep, then do anything else indicated */
#define MA_RESET  4     /* reset all "selected" bits */
#define MA_SELECT 8     /* change "selected" bits to reflect changed values */

/* errors returned by UIbuild_menu() */
#define ME_NOMEM     (void *) -1   /* unable to malloc() memory */
#define ME_TOOBIG    (void *) -2   /* menu wouldn't fit on screen */
#define ME_BADITEM   (void *) -3   /* bad entry in array of menu items */

/*-------------------------------------------------------*/
/* Types for UImenu_build() and UImenu_show()            */

typedef struct
   {
   char *title ;
   int row ;
   int col ;
   int left_button ;
   int right_button ;
   int allow_kbd ;
   char marker ;
   } MENU_OPTIONS ;

typedef struct
   {
   char type ;
   char *entry ;
   BYTE key1 ;
   BYTE key2 ;
   BYTE selected ;
   } MENU_ITEM ;

/***********************************************************/
/*           the user-interface function calls             */
/***********************************************************/

void * pascal UImenu_build(MENU_ITEM *menu_items,MENU_OPTIONS *menu_options) ;
int pascal UImenu_show(void *menu,int reset,int (*test)(OBJECT,int,char *),
                       char *result) ;
OBJECT pascal UIwin_open(OBJECT parent,int minrows,int mincols,
                         int maxrows,int maxcols,int defrows,int defcols) ;
void (* pascal UIsignal(int signal,OBJECT window,
                            void (*handler)(NOTIFY_MSG far *)))(NOTIFY_MSG far *) ;

